/*
Flasher
PB2 - PPM-signal
PB1, PB4 - out
CKSEL0=on; SUT0=on; CKDIV8=on; SPIEN=on (default fuses)
*/ 

#include <avr/io.h>
#define F_CPU 1200000UL // 1.2 MHz
#include <util/delay.h>

uint8_t mode = 0;

void always() {
PORTB |= ((1<<1)|(1<<4));
}

void flash() {
PORTB |= ((1<<1)|(1<<4));
_delay_ms(100);
PORTB &= ~((1<<1)|(1<<4));
_delay_ms(700);
}

void doubleflash() {
PORTB |= ((1<<1)|(1<<4));
_delay_ms(100);
PORTB &= ~((1<<1)|(1<<4));
_delay_ms(100);
PORTB |= ((1<<1)|(1<<4));
_delay_ms(100);
PORTB &= ~((1<<1)|(1<<4));
_delay_ms(700);
}

void change() {
PORTB |= (1<<1);
PORTB &= ~(1<<4);
_delay_ms(500);
PORTB |= (1<<4);
PORTB &= ~(1<<1);
_delay_ms(500);
}

void off() {
PORTB &= ~(1<<4);
PORTB &= ~(1<<1);
}

void siren() {
PORTB |= (1<<1); _delay_ms(50);
PORTB &= ~(1<<1); _delay_ms(50);
PORTB |= (1<<1); _delay_ms(50);
PORTB &= ~(1<<1); _delay_ms(50);
PORTB |= (1<<1); _delay_ms(50);
PORTB &= ~(1<<1); _delay_ms(50);

PORTB |= (1<<4); _delay_ms(50);
PORTB &= ~(1<<4); _delay_ms(50);
PORTB |= (1<<4); _delay_ms(50);
PORTB &= ~(1<<4); _delay_ms(50);
PORTB |= (1<<4); _delay_ms(50);
PORTB &= ~(1<<4); _delay_ms(50);
}

void HardwareInit() {
PORTB |= (1<<2);
DDRB &= (1<<2);
PORTB &= ~((1<<1)|(1<<4));
DDRB |= ((1<<1)|(1<<4));
}

int main(void)
{
HardwareInit();
while(1)
{
mode = 0;
while ( (PINB&(1<<2)) == (1<<2) ) {};
while ( (PINB&(1<<2)) == 0b00000000 ) {};
_delay_us(1200);
if ( (PINB&(1<<2)) == (1<<2) ) mode++ ;
_delay_us(200);
if ( (PINB&(1<<2)) == (1<<2) ) mode++ ;
_delay_us(200);
if ( (PINB&(1<<2)) == (1<<2) ) mode++ ;
if ( mode == 0 ) off();
if ( mode == 1 ) doubleflash();
if ( mode == 2 ) siren();
if ( mode == 3 ) always();
}
}

